/* grp_flows.c
 * Group flows core functions
 *
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "flow.h"
#include "grp_flows.h"


/** internal variables */


static flow *volatile gflow_tbl;           /* table of group flows... all group flows */
static volatile unsigned long tbl_dim;     /* dimension of table */
static volatile unsigned long gflow_num;   /* number of open group flows */
static pthread_mutex_t gflow_mux;          /* mutex to access atomicly the tbl */


int GrpFlowInit(void)
{

    return 0;
}


int GrpFlowCreate(int flow_id)
{
    int id;

    id = 0;
    FlowGrpSet(flow_id , id);

    return 0;
}


int GrpFlowAdd(int gflow_id, int flow_id)
{
    FlowGrpSet(flow_id , gflow_id);

    return 0;
}


int GrpFlowRm(int gflow_id, int flow_id)
{
    FlowGrpSet(flow_id , -1);

    return 0;
}


int GrpFlowDelete(int gflow_id)
{
    return 0;
}


bool GrpFlowEmpty(int gflow_id)
{

    return TRUE;
}

