/* dmemory.h
 *
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __DMEMORY_H__
#define __DMEMORY_H__

#include <stdlib.h>

//#define POI 1

void *XMalloc(size_t size, const char *function, int line);
void XFree(void *ptr, const char *function, int line);
void *XRealloc(void *ptr, size_t size, const char *function, int line);

#define xmalloc(size)       XMalloc(size, __FUNCTION__, __LINE__)
#define xfree(ptr)          XFree(ptr, __FUNCTION__, __LINE__)
#define xrealloc(ptr, size) XRealloc(ptr, size, __FUNCTION__, __LINE__)


#ifdef POI
int DMemInit(void);
void *DMemMalloc(size_t size);
void DMemFree(void *ptr);
void DMemEmpty(void);
void DMemState(void);
#else
#define DMemInit()   0
#define DMemMalloc(c) xmalloc(c)
#define DMemFree(c)   xfree(c)
#define DMemEmpty()
#define DMemState()
#endif


#endif /* __DMEMORY_H__ */
