/* grp_flows.h
 *
 *
 * Xplico - Internet Traffic Decoder
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __GRP_FLOW_H__
#define __GRP_FLOW_H__

#include <pthread.h>

#include "flow.h"

/* define */


/** group flow descriptor */
typedef struct _gflows gflows;
struct _gflows {
    bool fuse;        /**< all flows in the group are fuse in one flow dissector */
    int fthd_id;      /**< flow thread id of main flow in the group */
    int flow_list[FLOW_GROUP_DIM]; /**< flow list in the group */
    int fnum;         /**< number of flow */
};


/** group flow functions */
int GrpFlowInit(void);
int GrpFlowCreate(int flow_id);
int GrpFlowAdd(int gflow_id, int flow_id);
int GrpFlowRm(int gflow_id, int flow_id);
int GrpFlowDelete(int gflow_id);
bool GrpFlowEmpty(int gflow_id);



#endif /* __GRP_FLOW_H__ */
