/* dbinterface.h
 *
 *
 * Xplico System
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __DBINTEFACE_H__
#define __DBINTERACE_H__

#include "captime.h"

/* common */
#define DBINT_DIR_PATH        "/xplico/pol_%d/sol_%d"
#define DBINT_QUERY_DIM           10240
#define DBINT_QUERY_START_DEC         "UPDATE sols SET status='DECODING' WHERE id='%d';"
#define DBINT_QUERY_END_DEC           "UPDATE sols SET status='DECODING COMPLETED' WHERE id='%d';"

/* mysql */

/* sqlite */
#define DBINT_DB_FILE         "/xplico/xplico.db" /* DB file path */
#define DBINT_2_QUERY_START_T_TEMPLATE  "UPDATE sols SET start_time=DATETIME('NOW', 'LOCALTIME', '-%lu seconds') WHERE id='%d' AND start_time='0000-00-00 00:00:00';"
#define DBINT_2_QUERY_END_T_TEMPLATE    "UPDATE sols SET end_time=DATETIME('NOW', 'LOCALTIME', '-%lu seconds') WHERE id='%d';"
#define DBINT_2_QUERY_INPUT_FILE        "INSERT INTO inputs (pol_id, sol_id, start_time, end_time, data_size, filename, md5, sha1) VALUES (%i, %i, DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), DATETIME('NOW', 'LOCALTIME', '-%lu seconds'), %lu, '%s', '%s', '%s');"

typedef enum {
    DB_MYSQL,
    DB_SQLITE
} DBType;


int DBIntInit(DBType type);
int DBIntCapTime(int poi_id, int sol_id, cap_time *ctime);
int DBIntDecStart(int poi_id, int sol_id);
int DBIntDecEnd(int poi_id, int sol_id);
int DBIntInputPcap(int poi_id, int sol_id, cap_time *ctime, unsigned long size,
                   const char *name, const char *md5, const char *sha1);

#endif /* __DBINTERACE_H__ */
