/* dema.h
 * monitoring tables
 *
 *
 * Xplico System
 * By Gianluca Costa <g.costa@iserm.com>
 * Copyright 2007 Gianluca Costa & Andrea de Franceschi. Web: www.xplico.org
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#ifndef __DEMA_H__
#define __DEMA_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define DM_FILENAME_PATH         2048
#define DM_TBL_ADD               500
#define DM_HASH_STR              1024
#define DM_POL_NAME              "pol_"
#define DM_SESSION_NAME          "sol_"
#define DM_POL_DIR               "%s/pol_%i"
#define DM_TMP_DIR               "%s/pol_%i/tmp"
#define DM_LOG_DIR               "%s/pol_%i/log"
#define DM_NEW_DIR               "%s/pol_%i/sol_%i/new"
#define DM_RAW_DIR               "%s/pol_%i/sol_%i/raw"
#define DM_DECOD_DIR             "%s/pol_%i/sol_%i/decode"
#define DM_HISTORY_DIR           "%s/pol_%i/sol_%i/history"
#define DM_XPLICO_CFG            "xplico.cfg"
#define POL_INIT_SESSION_FILE    "pol_sinit.cfg"
#define POL_END_SESSION_FILE     "pol_send.cfg"
#define DB_T_MYSQL               "mysql"
#define DB_T_SQLITE              "sqlite"


/** boolean type */
typedef unsigned char bool;
#define TRUE     (0==0)
#define FALSE    (!TRUE)


/** task pid list  */
typedef struct _task task;
struct _task {
    pid_t xplico;
};


/** pol->session & decoder  */
typedef struct _podec podec;
struct _podec {
    int pol_id;                  /* pol ID */
    int sol_id;                  /* sol ID */
    bool run;                    /* task running */
    task pid;                    /* task pid */
    bool end;                    /* closing task */
    char name[DM_FILENAME_PATH]; /* file name */
    off_t size;                  /* size of last file */
    int filenum;                 /* file number */
};

#endif /* __DEMA_H__ */
